"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("underscore");
const validator = require("validator");
/* tslint:disable:rule1 no-shadowed-variable */
const dotty = require('dotty');
const required = (ctx, path, val) => val != null;
exports.required = required;
function contains(seed) {
    const contains = (ctx, path, val) => val == null || validator.contains(val, seed);
    return contains;
}
exports.contains = contains;
function equals(comparison) {
    const equals = (ctx, path, val) => val == null || validator.equals(val, comparison);
    return equals;
}
exports.equals = equals;
function isAfter(date) {
    const isAfter = (ctx, path, val) => val == null || validator.isAfter(val, date);
    return isAfter;
}
exports.isAfter = isAfter;
function isAlpha(locale) {
    const isAlpha = (ctx, path, val) => val == null || validator.isAlpha(val, locale);
    return isAlpha;
}
exports.isAlpha = isAlpha;
function isAlphanumeric(locale) {
    const isAlphanumeric = (ctx, path, val) => val == null || validator.isAlphanumeric(val, locale);
    return isAlphanumeric;
}
exports.isAlphanumeric = isAlphanumeric;
const isAscii = (ctx, path, val) => val == null || validator.isAscii(val);
exports.isAscii = isAscii;
const isBase64 = (ctx, path, val) => val == null || validator.isBase64(val);
exports.isBase64 = isBase64;
function isBefore(date) {
    const isBefore = (ctx, path, val) => val == null || validator.isBefore(val, date);
    return isBefore;
}
exports.isBefore = isBefore;
const isBoolean = (ctx, path, val) => val == null || validator.isBoolean(val);
exports.isBoolean = isBoolean;
function isByteLength(a, b) {
    const isByteLength = (ctx, path, val) => val == null || validator.isByteLength(val, a, b);
    return isByteLength;
}
exports.isByteLength = isByteLength;
const isCreditCard = (ctx, path, val) => validator.isCreditCard(val);
exports.isCreditCard = isCreditCard;
function isCurrency(options) {
    const isCurrency = (ctx, path, val) => val == null || validator.isCurrency(val, options);
    return isCurrency;
}
exports.isCurrency = isCurrency;
const isDataURI = (ctx, path, val) => val == null || validator.isDataURI(val);
exports.isDataURI = isDataURI;
function isDecimal(options) {
    const isDecimal = (ctx, path, val) => val == null || validator.isDecimal(val, options);
    return isDecimal;
}
exports.isDecimal = isDecimal;
function isDivisibleBy(number) {
    const isDivisibleBy = (ctx, path, val) => val == null || validator.isDivisibleBy(val, number);
    return isDivisibleBy;
}
exports.isDivisibleBy = isDivisibleBy;
function isEmail(options) {
    const isEmail = (ctx, path, val) => val == null || validator.isEmail(val, options);
    return isEmail;
}
exports.isEmail = isEmail;
const isEmpty = (ctx, path, val) => val == null || validator.isEmpty(val);
exports.isEmpty = isEmpty;
function isEnum(enumObject) {
    const values = _.values(enumObject);
    const isEnum = (ctx, path, val) => val == null || _.indexOf(values, val) >= 0;
    return isEnum;
}
exports.isEnum = isEnum;
function isFQDN(options) {
    const isFQDN = (ctx, path, val) => val == null || validator.isFQDN(val, options);
    return isFQDN;
}
exports.isFQDN = isFQDN;
function isFloat(options) {
    const isFloat = (ctx, path, val) => val == null || validator.isFloat(val, options);
    return isFloat;
}
exports.isFloat = isFloat;
const isFullWidth = (ctx, path, val) => val == null || validator.isFullWidth(val);
exports.isFullWidth = isFullWidth;
const isHalfWidth = (ctx, path, val) => val == null || validator.isHalfWidth(val);
exports.isHalfWidth = isHalfWidth;
function isHash(algorithm) {
    const isHash = (ctx, path, val) => val == null || validator.isHash(val, algorithm);
    return isHash;
}
exports.isHash = isHash;
const isHexColor = (ctx, path, val) => val == null || validator.isHexColor(val);
exports.isHexColor = isHexColor;
const isHexadecimal = (ctx, path, val) => val == null || validator.isHexadecimal(val);
exports.isHexadecimal = isHexadecimal;
function isIP(version) {
    const isIP = (ctx, path, val) => val == null || validator.isIP(val, version);
    return isIP;
}
exports.isIP = isIP;
function isISSN(options) {
    const isISSN = (ctx, path, val) => val == null || validator.isISSN(val, options);
    return isISSN;
}
exports.isISSN = isISSN;
const isISIN = (ctx, path, val) => val == null || validator.isISIN(val);
exports.isISIN = isISIN;
const isISO8601 = (ctx, path, val) => val == null || validator.isISO8601(val);
exports.isISO8601 = isISO8601;
const isISO31661Alpha2 = (ctx, path, val) => val == null || validator.isISO31661Alpha2(val);
exports.isISO31661Alpha2 = isISO31661Alpha2;
const isISRC = (ctx, path, val) => val == null || validator.isISRC(val);
exports.isISRC = isISRC;
function isIn(values) {
    const isIn = (ctx, path, val) => val == null || validator.isIn(val, values);
    return isIn;
}
exports.isIn = isIn;
function isInt(options) {
    const isInt = (ctx, path, val) => val == null || validator.isInt(val, options);
    return isInt;
}
exports.isInt = isInt;
const isJSON = (ctx, path, val) => val == null || validator.isJSON(val);
exports.isJSON = isJSON;
const isLatLong = (ctx, path, val) => val == null || validator.isLatLong(val);
exports.isLatLong = isLatLong;
function isLength(a, b) {
    const isLength = (ctx, path, val) => {
        if (val == null) {
            return true;
        }
        else if (_.isArray(val)) {
            return a <= val.length && (b == null || val.length <= b);
        }
        else {
            return validator.isLength(val, a, b);
        }
    };
    return isLength;
}
exports.isLength = isLength;
const isString = (ctx, path, val) => val == null || _.isString(val);
exports.isString = isString;
const isArray = (ctx, path, val) => val == null || _.isArray(val);
exports.isArray = isArray;
const isNumber = (ctx, path, val) => val == null || _.isNumber(val);
exports.isNumber = isNumber;
const isLowercase = (ctx, path, val) => val == null || validator.isLowercase(val);
exports.isLowercase = isLowercase;
const isMACAddress = (ctx, path, val) => val == null || validator.isMACAddress(val);
exports.isMACAddress = isMACAddress;
const isMD5 = (ctx, path, val) => val == null || validator.isMD5(val);
exports.isMD5 = isMD5;
const isMimeType = (ctx, path, val) => val == null || validator.isMimeType(val);
exports.isMimeType = isMimeType;
function isMobilePhone(locale, options) {
    const isMobilePhone = (ctx, path, val) => val == null || validator.isMobilePhone(val, locale, options);
    return isMobilePhone;
}
exports.isMobilePhone = isMobilePhone;
const isMongoId = (ctx, path, val) => val == null || validator.isMongoId(val);
exports.isMongoId = isMongoId;
const isMultibyte = (ctx, path, val) => val == null || validator.isMultibyte(val);
exports.isMultibyte = isMultibyte;
const isNumeric = (ctx, path, val) => val == null || validator.isNumeric(val);
exports.isNumeric = isNumeric;
const isPort = (ctx, path, val) => val == null || validator.isPort(val);
exports.isPort = isPort;
function isPostalCode(locale) {
    const isPostalCode = (ctx, path, val) => val == null || validator.isPostalCode(val, locale);
    return isPostalCode;
}
exports.isPostalCode = isPostalCode;
const isSurrogatePair = (ctx, path, val) => val == null || validator.isSurrogatePair(val);
exports.isSurrogatePair = isSurrogatePair;
function isURL(options) {
    const isURL = (ctx, path, val) => val == null || validator.isURL(val, options);
    return isURL;
}
exports.isURL = isURL;
function isUUID(version) {
    const isUUID = (ctx, path, val) => val == null || validator.isUUID(val, version);
    return isUUID;
}
exports.isUUID = isUUID;
const isUppercase = (ctx, path, val) => val == null || validator.isUppercase(val);
exports.isUppercase = isUppercase;
const isVariableWidth = (ctx, path, val) => val == null || validator.isVariableWidth(val);
exports.isVariableWidth = isVariableWidth;
function isWhitelisted(chars) {
    const isWhitelisted = (ctx, path, val) => val == null || validator.isWhitelisted(val, chars);
    return isWhitelisted;
}
exports.isWhitelisted = isWhitelisted;
function matches(pattern, modifiers) {
    const matches = (ctx, path, val) => val == null || validator.matches(val, pattern, modifiers);
    return matches;
}
exports.matches = matches;
// --------------------------- Sanitizers ----------------------------------- //
function blacklist(chars) {
    const blacklist = (ctx, path, val) => {
        if (val != null) {
            dotty.put(ctx.request, path, validator.blacklist(val, chars));
        }
        return true;
    };
    return blacklist;
}
exports.blacklist = blacklist;
function escape(ctx, path, val) {
    if (val != null) {
        dotty.put(ctx.request, path, validator.escape(val));
    }
    return true;
}
exports.escape = escape;
function unescape(ctx, path, val) {
    if (val != null) {
        dotty.put(ctx.request, path, validator.unescape(val));
    }
    return true;
}
exports.unescape = unescape;
function ltrim(chars) {
    const ltrim = (ctx, path, val) => {
        if (val != null) {
            dotty.put(ctx.request, path, validator.ltrim(val, chars));
        }
        return true;
    };
    return ltrim;
}
exports.ltrim = ltrim;
function normalizeEmail(options) {
    const normalizeEmail = (ctx, path, val) => {
        if (val != null) {
            dotty.put(ctx.request, path, validator.normalizeEmail(val, options));
        }
        return true;
    };
    return normalizeEmail;
}
exports.normalizeEmail = normalizeEmail;
function rtrim(chars) {
    const rtrim = (ctx, path, val) => {
        if (val != null) {
            dotty.put(ctx.request, path, validator.rtrim(val, chars));
        }
        return true;
    };
    return rtrim;
}
exports.rtrim = rtrim;
function stripLow(keep_new_lines) {
    const stripLow = (ctx, path, val) => {
        if (val != null) {
            dotty.put(ctx.request, path, validator.stripLow(val, keep_new_lines));
        }
        return true;
    };
    return stripLow;
}
exports.stripLow = stripLow;
function toBoolean(strict) {
    const toBoolean = (ctx, path, val) => {
        if (val != null && !_.isBoolean(val)) {
            dotty.put(ctx.request, path, validator.toBoolean(val, strict));
        }
        return true;
    };
    return toBoolean;
}
exports.toBoolean = toBoolean;
function toDate(ctx, path, val) {
    if (val != null && !_.isDate(val)) {
        dotty.put(ctx.request, path, validator.toDate(val));
    }
    return true;
}
exports.toDate = toDate;
function toFloat(ctx, path, val) {
    if (val != null && !_.isNumber(val)) {
        dotty.put(ctx.request, path, validator.toFloat(val));
    }
    return true;
}
exports.toFloat = toFloat;
function toInt(radix) {
    const toInt = (ctx, path, val) => {
        if (val != null && !_.isNumber(val)) {
            dotty.put(ctx.request, path, validator.toInt(val, radix));
        }
        return true;
    };
    return toInt;
}
exports.toInt = toInt;
function trim(chars) {
    const trim = (ctx, path, val) => {
        if (val != null) {
            dotty.put(ctx.request, path, validator.trim(val, chars));
        }
        return true;
    };
    return trim;
}
exports.trim = trim;
function whitelist(chars) {
    const whitelist = (ctx, path, val) => {
        if (val != null) {
            dotty.put(ctx.request, path, validator.whitelist(val, chars));
        }
        return true;
    };
    return whitelist;
}
exports.whitelist = whitelist;

//# sourceMappingURL=validators.js.map
